package mods.ElectricRails;

import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

public class BlockMaglevCover extends BlockRailEx
{
    public BlockMaglevCover(int id, float speedAmplifier)
    {
        super(id, speedAmplifier, TileMaglevCover.class);
        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.0625F, 1.0F);
    }

    @Override
    public void setBlockBoundsBasedOnState(IBlockAccess world, int x, int y, int z)
    {
        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.0625F, 1.0F);
    }

    //@Override
    //public AxisAlignedBB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
    //{
    //    return AxisAlignedBB.getAABBPool().getAABB(x + minX, y + minY, z + minZ, x + maxX, y + maxY/2.0F, z + maxZ);
    //}

    @Override
    public void onNeighborBlockChange(World world, int x, int y, int z, int neighborID)
    {
        super.onNeighborBlockChange(world, x, y, z, neighborID);

        // When neighbor block is changed, cover should update it's linked rails, e.g. reset linked rails and force to find rails again
        if (world.isRemote) return;
        TileEntity tile = world.getBlockTileEntity(x, y, z);
        if (tile != null && tile instanceof TileMaglevCover)
        {
            ((TileMaglevCover) tile).updateRails(true);
        }
    }

    @Override
    public boolean canMakeSlopes(World world, int x, int y, int z)
    {
        return false;
    }
}
