package mods.ElectricRails;

import net.minecraft.block.BlockRail;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.world.World;

public class BlockRailEx extends BlockRail
{
    public ItemStack stack1;
    public float speedAmplifier;
    public Class<? extends TileEntity> tileEntity;

    public BlockRailEx(int id, float speedAmplifier, Class<? extends TileEntity> tileEntity)
    {
        super(id);
        this.stack1 = new ItemStack(this);
        this.speedAmplifier = speedAmplifier;
        this.tileEntity = tileEntity;
    }

    @Override
    public float getRailMaxSpeed(World world, EntityMinecart cart, int y, int x, int z)
    {
        return super.getRailMaxSpeed(world, cart, y, x, z) * speedAmplifier;
    }

    @Override
    public boolean hasTileEntity(int metadata)
    {
        return tileEntity != null;
    }

    @Override
    public TileEntity createTileEntity(World world, int metadata)
    {
        try
        {
            return tileEntity != null ? tileEntity.newInstance() : null;
        }
        catch (InstantiationException e)
        {
            e.printStackTrace();
            return null;
        }
        catch (IllegalAccessException e)
        {
            e.printStackTrace();
            return null;
        }
    }
}
