package mods.ElectricRails;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.network.INetworkManager;
import net.minecraft.network.packet.Packet250CustomPayload;
import net.minecraft.world.World;

import org.apache.commons.io.output.ByteArrayOutputStream;

import cpw.mods.fml.common.network.IPacketHandler;
import cpw.mods.fml.common.network.PacketDispatcher;
import cpw.mods.fml.common.network.Player;

public class PacketHandler implements IPacketHandler
{
    public static final String effectChannel = "ERAIL|GFX";

    @Override
    public void onPacketData(INetworkManager manager, Packet250CustomPayload packet, Player player)
    {
        if (effectChannel.equals(packet.channel))
        {
            World w = ((EntityPlayer) player).worldObj;
            if (w.isRemote) handleEffect(packet, w);
        }
    }

    private static void handleEffect(Packet250CustomPayload packet, World w)
    {
        try
        {
            ByteArrayInputStream bs = new ByteArrayInputStream(packet.data);
            DataInputStream ds = new DataInputStream(bs);
            double x = ds.readDouble();
            double y = ds.readDouble();
            double z = ds.readDouble();
            EntitySparksFX.spawnSparks(w, x, y, z);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }

    public static void sendSparks(World w, double x, double y, double z)
    {
        try
        {
            ByteArrayOutputStream bs = new ByteArrayOutputStream();
            DataOutputStream ds = new DataOutputStream(bs);
            ds.writeDouble(x);
            ds.writeDouble(y);
            ds.writeDouble(z);
            ds.flush();
            ds.close(); // it actually don't need to be closed, because of memory stream
            Packet250CustomPayload p = new Packet250CustomPayload(effectChannel, bs.toByteArray());
            PacketDispatcher.sendPacketToAllAround(x, y, z, 64, w.provider.dimensionId, p);
        }
        catch (IOException e)
        {
            e.printStackTrace();
        }
    }

}
