package mods.ElectricRails.meta;

public class Database
{
    // Electric Rail item, for backward compatibility with previous version should have metadata index 0

    public static final MetaItem electricRail = new MetaItem("electricRail", "electric_rail");

    // Materials from rare earth elements

    //public static final MetaMaterial scandium     = new MetaMaterial(21, "Sc", "Scandium",     1814, false);
    public static final MetaMaterial yttrium      = new MetaMaterial(39, "Y",  "Yttrium",      1799);
    public static final MetaMaterial lanthanum    = new MetaMaterial(57, "La", "Lanthanum",    1193);
    public static final MetaMaterial cerium       = new MetaMaterial(58, "Ce", "Cerium",       1068);
    public static final MetaMaterial praseodymium = new MetaMaterial(59, "Pr", "Praseodymium", 1208);
    public static final MetaMaterial neodymium    = new MetaMaterial(60, "Nd", "Neodymium",    1297);
    //public static final MetaMaterial promethium   = new MetaMaterial(61, "Pm", "Promethium",   1315, true); // too rare
    public static final MetaMaterial samarium     = new MetaMaterial(62, "Sm", "Samarium",     1345);
    public static final MetaMaterial europium     = new MetaMaterial(63, "Eu", "Europium",     1099);
    public static final MetaMaterial gadolinium   = new MetaMaterial(64, "Gd", "Gadolinium",   1585);
    public static final MetaMaterial terbium      = new MetaMaterial(65, "Tb", "Terbium",      1629);
    public static final MetaMaterial dysprosium   = new MetaMaterial(66, "Dy", "Dysprosium",   1680);
    public static final MetaMaterial holmium      = new MetaMaterial(67, "Ho", "Holmium",      1734);
    public static final MetaMaterial erbium       = new MetaMaterial(68, "Er", "Erbium",       1802);
    public static final MetaMaterial thulium      = new MetaMaterial(69, "Tm", "Thulium",      1818);
    public static final MetaMaterial ytterbium    = new MetaMaterial(70, "Yb", "Ytterbium",    1097);
    public static final MetaMaterial lutetium     = new MetaMaterial(71, "Lu", "Lutetium",     1925);

    // All materials, for automatic recipe generation

    public static final MetaMaterial[] materials = {
        yttrium,
        lanthanum,
        cerium,
        praseodymium,
        neodymium,
        samarium,
        europium,
        gadolinium,
        terbium,
        dysprosium,
        holmium,
        erbium,
        thulium,
        ytterbium,
        lutetium
    };

    // General Items list

    public static final MetaItem[] items = {
        electricRail/*,

        yttrium.dust,      yttrium.dust.small,      yttrium.dust.tiny,      yttrium.nugget,      yttrium.ingot,      yttrium.plate,
        lanthanum.dust,    lanthanum.dust.small,    lanthanum.dust.tiny,    lanthanum.nugget,    lanthanum.ingot,    lanthanum.plate,
        cerium.dust,       cerium.dust.small,       cerium.dust.tiny,       cerium.nugget,       cerium.ingot,       cerium.plate,
        praseodymium.dust, praseodymium.dust.small, praseodymium.dust.tiny, praseodymium.nugget, praseodymium.ingot, praseodymium.plate,
        neodymium.dust,    neodymium.dust.small,    neodymium.dust.tiny,    neodymium.nugget,    neodymium.ingot,    neodymium.plate,
        samarium.dust,     samarium.dust.small,     samarium.dust.tiny,     samarium.nugget,     samarium.ingot,     samarium.plate,
        europium.dust,     europium.dust.small,     europium.dust.tiny,     europium.nugget,     europium.ingot,     europium.plate,
        gadolinium.dust,   gadolinium.dust.small,   gadolinium.dust.tiny,   gadolinium.nugget,   gadolinium.ingot,   gadolinium.plate,
        terbium.dust,      terbium.dust.small,      terbium.dust.tiny,      terbium.nugget,      terbium.ingot,      terbium.plate,
        dysprosium.dust,   dysprosium.dust.small,   dysprosium.dust.tiny,   dysprosium.nugget,   dysprosium.ingot,   dysprosium.plate,
        holmium.dust,      holmium.dust.small,      holmium.dust.tiny,      holmium.nugget,      holmium.ingot,      holmium.plate,
        erbium.dust,       erbium.dust.small,       erbium.dust.tiny,       erbium.nugget,       erbium.ingot,       erbium.plate,
        thulium.dust,      thulium.dust.small,      thulium.dust.tiny,      thulium.nugget,      thulium.ingot,      thulium.plate,
        ytterbium.dust,    ytterbium.dust.small,    ytterbium.dust.tiny,    ytterbium.nugget,    ytterbium.ingot,    ytterbium.plate,
        lutetium.dust,     lutetium.dust.small,     lutetium.dust.tiny,     lutetium.nugget,     lutetium.ingot,     lutetium.plate,*/
    };

    // Storage Blocks

    public static final MetaItem[] blocks1 = {
        yttrium.block,
        lanthanum.block,
        cerium.block,
        praseodymium.block,
        neodymium.block,
        samarium.block,
        europium.block,
        gadolinium.block,
        terbium.block,
        dysprosium.block,
        holmium.block,
        erbium.block,
        thulium.block,
        ytterbium.block,
        lutetium.block
    };
}
