package mods.ElectricRails.meta;

import net.minecraft.item.ItemStack;
import net.minecraft.util.Icon;

/**
 * Fields not marked as <b>final</b> should be filled once item is hosted... <b>if</b> item is hosted.
 * If item is not hosted, this fields will remain <b>null</b>.
 * MetaItems becomes alive through hosting them on a specified item.
 */
public class MetaItem
{
    public final String unlocalizedName, textureName, chemical;
    public ItemStack stack1 = null, stack4 = null, stack9 = null;
    public Icon icon = null;

    /**
     * Constructor for materials.
     */
    public MetaItem(String unlocalizedName, String textureName, String chemical)
    {
        this.unlocalizedName = unlocalizedName;
        this.textureName = textureName;
        this.chemical = chemical;
    }

    /**
     * Constructor for simple items.
     */
    public MetaItem(String unlocalizedName, String textureName)
    {
        this(unlocalizedName, textureName, null);
    }
}
